ListRecommendationsForResource
List all Trusted Advisor recommendations for a given AWS resource ARN.
Request Syntax
GET /v1/recommendations-for-resource/awsResourceArn?checkArn=checkArn&language=language&maxResults=maxResults&nextToken=nextToken&pillar=pillar&status=status HTTP/1.1
URI Request Parameters
The request uses the following URI parameters.
- awsResourceArn
-
The ARN of the AWS resource to query recommendations for
Length Constraints: Minimum length of 20. Maximum length of 2048.
Pattern:
arn:aws(-\w+)*:[\w\d-]+:([\w\d-]*)?:[\w\d_-]*([:/].+)*Required: Yes
- checkArn
-
The AWS Trusted Advisor Check ARN that relates to the Recommendation
Length Constraints: Minimum length of 20. Maximum length of 2048.
Pattern:
arn:[\w-]+:trustedadvisor:::check\/[\w-]+ - language
-
The ISO 639-1 code for the language that you want your recommendations to appear in.
Valid Values:
en | ja | zh | fr | de | ko | zh_TW | it | es | pt_BR | id - maxResults
-
The maximum number of results to return per page
Valid Range: Minimum value of 1. Maximum value of 600.
- nextToken
-
The token for the next set of results. Use the value returned in the previous response in the next request to retrieve the next set of results.
Length Constraints: Minimum length of 4. Maximum length of 10000.
- pillar
-
The pillar that the recommendation belongs to
Valid Values:
cost_optimizing | performance | security | service_limits | fault_tolerance | operational_excellence - status
-
The current status of the Recommendation Resource
Valid Values:
ok | warning | error
Request Body
The request does not have a request body.
Response Syntax
HTTP/1.1 200
Content-type: application/json
{
"nextToken": "string",
"recommendationForResourceSummaries": [
{
"awsResourceArn": "string",
"checkArn": "string",
"exclusionStatus": "string",
"lastUpdatedAt": "string",
"metadata": {
"string" : "string"
},
"pillars": [ "string" ],
"recommendationArn": "string",
"status": "string"
}
]
}
Response Elements
If the action is successful, the service sends back an HTTP 200 response.
The following data is returned in JSON format by the service.
- nextToken
-
The token for the next set of results. Use the value returned in the previous response in the next request to retrieve the next set of results.
Type: String
Length Constraints: Minimum length of 4. Maximum length of 10000.
- recommendationForResourceSummaries
-
List of Trusted Advisor recommendations associated with the given AWS resource
Type: Array of RecommendationForResourceSummary objects
Errors
For information about the errors that are common to all actions, see Common Error Types.
- AccessDeniedException
-
Exception that access has been denied due to insufficient access
HTTP Status Code: 403
- InternalServerException
-
Exception to notify that an unexpected internal error occurred during processing of the request
HTTP Status Code: 500
- ThrottlingException
-
Exception to notify that requests are being throttled
HTTP Status Code: 429
- ValidationException
-
Exception that the request failed to satisfy service constraints
HTTP Status Code: 400
Examples
List All Recommendations for an AWS Resource
List all Trusted Advisor recommendations associated with an AWS resource by its ARN.
Sample Request
{
"awsResourceArn": "arn:aws:ec2:us-east-1:000000000000:instance/i-0abcd1234efgh5678"
}
Sample Response
{
"recommendationForResourceSummaries": [
{
"checkArn": "arn:aws:trustedadvisor:::check/Qch7DwouX1",
"recommendationArn": "arn:aws:trustedadvisor::000000000000:recommendation/55fa4d2e-bbb7-491a-833b-5773e9589578",
"awsResourceArn": "arn:aws:ec2:us-east-1:000000000000:instance/i-0abcd1234efgh5678",
"status": "warning",
"lastUpdatedAt": "2026-05-21T15:09:51.891Z",
"exclusionStatus": "included",
"metadata": {
"Region": "us-east-1",
"Resource": "i-0abcd1234efgh5678",
"Status": "Yellow"
},
"pillars": [
"cost_optimizing"
]
}
],
"nextToken": "REDACTED"
}
See Also
For more information about using this API in one of the language-specific AWS SDKs, see the following: